#ifndef  __GRDICONSWRAPPER
#define  __GRDICONSWRAPPER

#include <windows.h>
#include <commctrl.h>
#include <shellapi.h>
#include <stdio.h>
#include "grdSysTraySettings.h"

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * STRUCTURE: GRDSYSTRAYICON                               * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* *                                                         * */
/* *  this is the structure that is stored for every icon    * */
/* *                                                         * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

typedef struct GRDSYSTRAYICON {

	// owner window
	HWND hWnd;
	// id
	UINT uID;
	// flags
	UINT uFlags;
	// callback message ( to send to the owner window )
	UINT uCallbackMessage;
	// icon
	HICON hIcon;
	// trayicon area
	RECT rc;

	// tooltip text
	char *szTip;
	// tooltip id
	UINT uToolTip;

	struct GRDSYSTRAYICON *pNext, *pPrev;

} GRDSYSTRAYICON, *PGRDSYSTRAYICON, FAR *LPGRDSYSTRAYICON;


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * CLASS: grdIconsWrapper                                  * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* *                                                         * */
/* *  this class stores the icon information in a really     * */
/* *  smart way and prints the layout to a dc desiring it.   * */
/* *                                                         * */
/* *  other than that grdTray is a really great LoadModule   * */
/* *                                                         * */
/* *                                      // Gustav Munkby   * */
/* *                                                         * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

class grdIconsWrapper {

	public:

		// this one loads the wrapper from an ini-file
		grdIconsWrapper( HWND hTray, HWND hParent, grdSysTraySettings *cfg );
		// this one saves the wrapper to an ini-file
		~grdIconsWrapper();

		PGRDSYSTRAYICON add( PNOTIFYICONDATA pnid );
		BOOL            del( PNOTIFYICONDATA pnid );
		PGRDSYSTRAYICON modify( PNOTIFYICONDATA pnid );
		
		PGRDSYSTRAYICON find( HWND hWnd, UINT uID );
		PGRDSYSTRAYICON findPt( POINT pt );

		// to delete the complete list
		BOOL            delList();

		// to paint the icons to a dc
		void            iconsOut( HDC hdcDest );

		// these are stolen from the LS source code (more or less)		
		BOOL            save(void *dst);
		BOOL            load(void *src);

		HWND  hToolTip;

	private:

		BOOL            delInside( PGRDSYSTRAYICON pSysTrayIcon );

		// the pointers that this class uses
		PGRDSYSTRAYICON pFirst, pLast;

		// window handles needed
		HWND hSysTray, hLiteStep;

		UINT uLastID;

		// this is interesting
		grdSysTraySettings *settings;

};


#endif// __GRDICONSWRAPPER
