#ifndef  __GRDSYSTRAYSETTINGS
#define  __GRDSYSTRAYSETTINGS

#include <windows.h>

// defined directions
#define TD_VERTICAL    0x1
#define TD_TOTOPLEFT   0x2

#define TD_RIGHT       0x0
#define TD_LEFT        (TD_TOTOPLEFT)
#define TD_UP          (TD_TOTOPLEFT|TD_VERTICAL)
#define TD_DOWN        (TD_VERTICAL)

// defined effects
#define FX_ICONHUE     0x1
#define FX_SATURNATION 0x2

#define FX_ANY         (FX_ICONHUE|FX_SATURNATION)


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * CLASS: grdSysTraySettings                               * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* *                                                         * */
/* *  this sub-class handles everything that has anythin     * */
/* *  in common with loading settings and checking them      * */
/* *  for proper format and so on...                         * */
/* *                                                         * */
/* *  other than that grdTray is a really great LoadModule   * */
/* *                                                         * */
/* *                                      // Gustav Munkby   * */
/* *                                                         * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

class grdSysTraySettings {

	public:

		grdSysTraySettings();
		~grdSysTraySettings();

		void skinOut( HDC hdcDst );
		
		// booleans
		BOOL bAlwaysOnTop;
		BOOL bHideIfEmpty;
		BOOL bVisible;

		// tray
		int  nTrayX;
		int  nTrayY;
		int  nTrayWidth;
		int  nTrayHeight;

		// borders
		UINT uBorderTop; 
		UINT uBorderLeft;
		UINT uBorderRight;
		UINT uBorderBottom;

		// tray wrapping
		UINT uDirection;
		UINT uWrapCount;
		UINT uWrapDirection;

		// icon
		UINT uIconSize;
		int  nIconSpacingX;
		int  nIconSpacingY;
		int  nDeltaX;
		int  nDeltaY;

		int  nFirstX;
		int  nLastX;
		int  nFirstY;
		int  nLastY;

		// icon effects
		COLORREF clrHue;
		UCHAR uHueIntensity;

		UCHAR uSaturnation;

		UCHAR uEffectFlags;

	private:

		// skinning
		HBITMAP hbmSkin;
		BOOL bSkinTiled;

		COLORREF clrBack;
		COLORREF clrBorder;

};


#endif// __GRDSYSTRAYSETTINGS